entry     movea.w   $0110,a2            ; BP.INIT
          lea       defblock,a1         ; definition block
          jsr       (a2)                ; call bp.init
          moveq     #0,d0               ; no error
          rts                           ; back to basic

*  Define SuperBASIC extensions
defblock  dc.w      3                   ; 3 procs
          dc.w      fload-*
          dc.b      5
          dc.b      'FLOAD'
          dc.w      fsave-*
          dc.b      5
          dc.b      'FSAVE'
          dc.w      flrun-*
          dc.b      5
          dc.b      'FLRUN'
          dc.w      0
          dc.w      0                   ; no functions
          dc.w      0
*  End SB ext

* FSAVE definition
fsave     move.w    #2,d1               ; open_new key for io.open
          bsr       lab100fe
          movea.l   a0,a2               ; channel ID
          moveq     #0,d0               ; mt.inf trap
          trap      #1
          move.l    $14(a0),d5          ; SV.TRNSP
          sub.l     a6,d5
          move.l    (a7),d4
          movea.l   a2,a0
          move.l    d5,d2
          movea.l   a6,a1
          moveq     #$49,d0             ; fs.save
Lab1004C  moveq     #-1,d3              ; timeout
          trap      #3
          move.l    d4,(a7)             ; save d4
Lab10052  move.l    d0,d4               ; preserve d0
          moveq     #2,d0               ; io.close
          trap      #2
          move.l    d4,d0               ; restore d0
          rts

* FLOAD definition
fload     move.w    #0,d1               ; open_in key for io.open
          bsr       lab100fe            ; fetch parameter and open
          tst.l     d0                  ; error?
          bne.s     lab10078
          bsr.s     lab1007a
          tst.l     d0
          bne.s     lab10078
          clr.w     $6c(a6)
          clr.b     $6f(a6)
          moveq     #0,d0
Lab10078  rts

Lab1007A  moveq     #$47,d0         ; fs.headr
          moveq     #$40,d2         ; buffer length 64 bytes
          moveq     #-1,d3          ; infinite timeout
          movea.l   (a6),a1         ; buffer base (bv.bfbas)
          lea       0(a6,a1.l),a1   ; base of read buffer
          trap      #3
          tst.l     d0              ; error?
          bne.s     lab10052        ; oops
          movea.l   (a6),a1
          move.l    0(a6,a1.l),d6
          movea.l   a0,a4
          trap      #0              ; supervisor mode
          move.l    usp,a5
          move.l    (a5),d4
          moveq     #0,d0           ; mt.inf
          trap      #1
          move.l    $1c(a0),d7          ; SV.RESPR
          moveq     #$16,d0
          movea.l   $14(a0),a3          ; SV.TRNSP
          move.l    a3,d1
          sub.l     a6,d1
          sub.l     d6,d1
          beq.s     lab100c4
          blt.s     lab100c0
          neg.l     d1
          moveq     #$7f,d0
Lab100B6  move.l    -(a3),0(a3,d1.l)
          dbf       d0,lab100b6
          moveq     #$17,d0           ;mt.rebas - release basic prog area
Lab100C0  neg.l     d1
          trap      #1

Lab100C4  move.l    a5,usp
          move.w    #0,sr
          movea.l   a4,a0
          movea.l   a6,a1
          moveq     #$48,d0
          move.l    d6,d2
          bra       lab1004c

flrun     move.w    #0,d1
          bsr.s     lab100fe
          tst.l     d0
          bne.s     lab10078
          bsr       lab1007a
          tst.l     d0
          bne.s     lab10078
          clr.w     $88(a6)             ; BV.NXLIN
          clr.b     $8a(a6)             ; BV.NXSTM
          clr.b     $6d(a6)             ; BV.CONT
          move.w    #6,$8c(a6)          ; BV.STOPN
          moveq     #0,d0
          rts

* fetch parameter
Lab100FE  move.w    d1,-(a7)            ; open key (2=open_new)
          movea.w   $0116,a2            ; CA.GTSTR fetch string parameter
          jsr       (a2)
          subq.w    #1,d3               ; 1 parameter?
          bne.s     bad_param           ; oops
          move.w    (a7)+,d3            ; open code
          lea       0(a6,a1.l),a0       ; point to string on stack
          moveq     #-1,d1              ; my own job ID
          moveq     #1,d0               ; io.open
          trap      #2
          rts

bad_param moveq     #-$0f,d0            ; ERR.BP
          addq.l    #6,a7
          rts

          end
